'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _backbone = require('backbone');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var connect = function connect(mapModelToProps) {
	for (var _len = arguments.length, renderEvents = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
		renderEvents[_key - 1] = arguments[_key];
	}

	var eventString = renderEvents.length ? renderEvents.join(' ') : 'change';
	return function (ComposedComponent) {
		var displayName = ComposedComponent.displayName || 'Component';

		var ContainerComponent = function (_Component) {
			_inherits(ContainerComponent, _Component);

			function ContainerComponent(props, context) {
				var _Object$getPrototypeO;

				_classCallCheck(this, ContainerComponent);

				if (!context.model && !props.model) {
					throw new Error('Could not find "model" in either the context or props of "' + displayName + '".');
				}

				for (var _len2 = arguments.length, rest = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
					rest[_key2 - 2] = arguments[_key2];
				}

				var _this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(ContainerComponent)).call.apply(_Object$getPrototypeO, [this, props, context].concat(rest)));

				_this.model = _this.props.model || _this.context.model;
				_this.model.on(eventString, function () {
					return _this.forceUpdate();
				});
				return _this;
			}

			_createClass(ContainerComponent, [{
				key: 'componentWillUnmount',
				value: function componentWillUnmount() {
					this.model.off(eventString);
				}
			}, {
				key: 'render',
				value: function render() {
					var mappedProps = mapModelToProps(this.model.toJSON(), this.model, this.props);
					return _react2.default.createElement(ComposedComponent, mappedProps);
				}
			}]);

			return ContainerComponent;
		}(_react.Component);

		ContainerComponent.contextTypes = {
			model: _react.PropTypes.oneOfType([_react.PropTypes.instanceOf(_backbone.Model), _react.PropTypes.instanceOf(_backbone.Collection)])
		};
		ContainerComponent.propTypes = {
			model: _react.PropTypes.oneOfType([_react.PropTypes.instanceOf(_backbone.Model), _react.PropTypes.instanceOf(_backbone.Collection)])
		};
		ContainerComponent.displayName = 'BackboneConnect(' + eventString + ')(' + displayName + ')';
		return ContainerComponent;
	};
};

exports.default = connect;